// Copyright (c) 1997 Andrew Maltsev <am@amsoft.ru>
// All rights reserved
// 
// Registering of statically linked drivers
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "es_int.h"

///////////////////////////////////////////////////////////////////////////////
// Static members of the register
//
easysql_register::driverdata *easysql_register::data=NULL;
unsigned easysql_register::ndata=0;

///////////////////////////////////////////////////////////////////////////////
// Driver registration. Because of absence of `unregister' feature for
// now it is only safe to register statically linked drivers (for which
// very reason that code has been written). May be it will be extended
// later to trace registering/unregistering more precise to allow
// dynamic shared object registration.
//
easysql_register::easysql_register(char const *name, void *(*iface)(char const *))
{ if(!name || !iface)
   { log(D_ERROR|D_DRV,"Invalid registration attempt; ignored");
     return;
   }
  if(ndata%10==0)
   data=(typeof(data))reAlloc(data,sizeof(*data)*(ndata+10));
  data[ndata].name=strDup(name);
  data[ndata].iface=iface;
  ndata++;

  log(D_DRV|D_L1,"Registered `%s' static driver",name);
}

///////////////////////////////////////////////////////////////////////////////
// Unregistering
//
easysql_register::~easysql_register()
{
}

///////////////////////////////////////////////////////////////////////////////
// Looking for previously registered driver
//
void *(*
       easysql_register::find(char const *name)
      )(char const *)
{ for(unsigned i=0; i!=ndata; i++)
   if(!strcasecmp(name,data[i].name))
    { log(D_DRV|D_L3,"Driver for `%s' found",name);
      return data[i].iface;
    }
  log(D_DRV|D_L4,"Driver `%s' not found in register",name);
  return NULL;
}

///////////////////////////////////////////////////////////////////////////////
R("$Id: es_reg.C,v 1.3 1997/10/23 18:40:40 am Exp $");
